//
//  ViewController.m
//  homeAutomation
//
//  Created by Elango, Ajay K on 4/26/14.
//  Copyright (c) 2014 Vivek,Apurv. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController
float home_latitude = 33.777546;
float home_longitude = -84.390236;

float current_latitude;
float current_longitude;

int auto_num = 0;
int security_num = 0;
int device1_num = 0;
int device2_num = 0;
int device3_num = 0;
int device4_num = 0;
int nearfar = 0; //By default its set to near

int manual_security_nearfar = 0;
int device_config = 0;

const float threshold_val = 0.0002;

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void) targetMethod:(NSTimer *)timer
{
    
    
    locationManager = [[CLLocationManager alloc] init];
    locationManager.distanceFilter = kCLDistanceFilterNone; // whenever we move
    //locationManager.desiredAccuracy = kCLLocationAccuracyHundredMeters; // 100 m
    locationManager.desiredAccuracy = kCLLocationAccuracyBest;
    [locationManager startUpdatingLocation];
    
    
    current_latitude = locationManager.location.coordinate.latitude;
    current_longitude = locationManager.location.coordinate.longitude;
    
    float diff_lat = current_latitude - home_latitude;
    float diff_long = current_longitude - home_longitude;
    _distanceFromHome.text = [NSString stringWithFormat:@"Lat: %f", diff_lat];
    _modeRecommended.text =[NSString stringWithFormat:@"Long: %f", diff_long];
    
    
    if (( diff_lat < threshold_val && diff_lat > -1 * threshold_val )  && (diff_long < 10 * threshold_val && diff_long > -10 * threshold_val ))
    {
        NSLog(@"Near");
        _relPos.text = @"Near";
        nearfar = 0;
        
    }
    else
    {
        NSLog(@"Far");
        _relPos.text = @"Far";
        nearfar = 1;
        
    }
    
    [self func_setModes];
    
    NSLog(@"Timer");
    
    NSString *message =[NSString stringWithFormat:@"My home location is http://maps.google.com/maps?q=%f,%f",current_latitude, current_longitude];
    
     // NSString *message =[NSString stringWithFormat:@"My home location is http://maps.google.com/maps?q=%s,%s","5", "13"];
    
    NSLog(@"%@", message);
    
    
    //NSString *post = [NSString stringWithFormat:@"&id=%s&gps_coordinates_lat=%f&gps_coordinates_lon=%f","123",home_latitude, home_longitude];
    
    NSString *post = [NSString stringWithFormat:@"&id=%s&gps_coordinates_lat=%d&gps_coordinates_lon=%d","123",manual_security_nearfar, device_config];
    
    NSData *postData = [post dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
    
    NSString *postLength = [NSString stringWithFormat:@"%lu",(unsigned long)[postData length]];
    
    NSMutableURLRequest *requestPost = [[NSMutableURLRequest alloc] init];
    
    [requestPost setURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://dev.m.gatech.edu/d/rsrs3/w/SilentGardian/c/api/updateGpsLocation"]]];
    
    //[requestPost setURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://dev.m.gatech.edu/d/rsrs3/w/SilentGardian/c/api/gpsLocation/"]]];
    
    //http://dev.m.gatech.edu/d/rsrs3/w/SilentGardian/c/api/gpsLocation/
    
    [requestPost setHTTPMethod:@"POST"];
    
    [requestPost setValue:postLength forHTTPHeaderField:@"Content-Length"];
    
    [requestPost setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Current-Type"];
    
    [requestPost setHTTPBody:postData];
    
    NSURLConnection *conn = [[NSURLConnection alloc]initWithRequest:requestPost delegate:self];
    
    if(conn)
    {
        NSLog(@"Connection Successful");
    }
    else
    {
        NSLog(@"Connection could not be made");
    }
    
  
    
}

- (IBAction)security:(id)sender {
    UISwitch *sw = (UISwitch*) sender;
    if(sw.on == 1)
    {
        security_num = 1;
    }
    else {
        security_num = 0;
    }
}

- (IBAction)device1:(id)sender {
    UISwitch *sw = (UISwitch*) sender;
    if(sw.on == 1)
    {
        device1_num = 1;
    }
    else {
        device1_num = 0;
    }
}

- (IBAction)device2:(id)sender {
    UISwitch *sw = (UISwitch*) sender;
    if(sw.on == 1)
    {
        device2_num = 1;
    }
    else {
        device2_num = 0;
    }
}

- (IBAction)device3:(id)sender {
    UISwitch *sw = (UISwitch*) sender;
    if(sw.on == 1)
    {
        device3_num = 1;
    }
    else {
        device3_num = 0;
    }
}

- (IBAction)device4:(id)sender {
    UISwitch *sw = (UISwitch*) sender;
    if(sw.on == 1)
    {
        device4_num = 1;
    }
    else {
        device4_num = 0;
    }
    
}

- (IBAction)locationTSRB:(id)sender {
    home_latitude = 33.777546;
    home_longitude = -84.390236;
    
}


- (IBAction)manual:(id)sender {
    
    UISwitch *sw = (UISwitch*) sender;
    
    if(sw.on == 1)
    {
        NSLog(@"Auto mode On");
        auto_num = 1;
        manual_security_nearfar = 4;
        
        [NSTimer scheduledTimerWithTimeInterval:60.0
                                         target:self
                                       selector:@selector(targetMethod:)
                                       userInfo:nil
                                        repeats:YES];
    }
    else {
        auto_num = 0;
        manual_security_nearfar = 0;
        
    }
    NSLog(@"Manual mode On");
}

- (IBAction)setGPS:(id)sender {
    
    locationManager = [[CLLocationManager alloc] init];
    locationManager.distanceFilter = kCLDistanceFilterNone; // whenever we move
    //locationManager.desiredAccuracy = kCLLocationAccuracyHundredMeters; // 100 m
    locationManager.desiredAccuracy = kCLLocationAccuracyBest;
    [locationManager startUpdatingLocation];
    
    home_latitude = locationManager.location.coordinate.latitude;
    home_longitude = locationManager.location.coordinate.longitude;
   
}

- (void) func_setModes;
{
    if((device1_num == 0) && (device2_num == 0) && (device3_num == 0) && (device4_num == 0)) { device_config = 0; }
    
    if((device1_num == 0) && (device2_num == 0) && (device3_num == 0) && (device4_num == 1)) { device_config = 1; }
    
    if((device1_num == 0) && (device2_num == 0) && (device3_num == 1) && (device4_num == 0)) { device_config = 2; }
    
    if((device1_num == 0) && (device2_num == 0) && (device3_num == 1) && (device4_num == 1)) { device_config = 3; }
    
    if((device1_num == 0) && (device2_num == 1) && (device3_num == 0) && (device4_num == 0)) { device_config = 4; }
    
    if((device1_num == 0) && (device2_num == 1) && (device3_num == 0) && (device4_num == 1)) { device_config = 5; }
    
    if((device1_num == 0) && (device2_num == 1) && (device3_num == 1) && (device4_num == 0)) { device_config = 6; }
    
    if((device1_num == 0) && (device2_num == 1) && (device3_num == 1) && (device4_num == 1)) { device_config = 7; }
    
    if((device1_num == 1) && (device2_num == 0) && (device3_num == 0) && (device4_num == 0)) { device_config = 8; }
    
    if((device1_num == 1) && (device2_num == 0) && (device3_num == 0) && (device4_num == 1)) { device_config = 9; }
    
    if((device1_num == 1) && (device2_num == 0) && (device3_num == 1) && (device4_num == 0)) { device_config = 10; }
    
    if((device1_num == 1) && (device2_num == 0) && (device3_num == 1) && (device4_num == 1)) { device_config = 11; }
    
    if((device1_num == 1) && (device2_num == 1) && (device3_num == 0) && (device4_num == 0)) { device_config = 12; }
    
    if((device1_num == 1) && (device2_num == 1) && (device3_num == 0) && (device4_num == 1)) { device_config = 13; }
    
    if((device1_num == 1) && (device2_num == 1) && (device3_num == 1) && (device4_num == 0)) { device_config = 14; }
    
    if((device1_num == 1) && (device2_num == 1) && (device3_num == 1) && (device4_num == 1)) { device_config = 15; }
    
    if ( (auto_num == 0) && (security_num == 0) && (nearfar == 0) ) {
        manual_security_nearfar = 0;
    }
    if ( (auto_num == 0) && (security_num == 0) && (nearfar == 1) ) {
        manual_security_nearfar = 1;
    }
    if ( (auto_num == 0) && (security_num == 1) && (nearfar == 0) ) {
        manual_security_nearfar = 2;
    }
    if ( (auto_num == 0) && (security_num == 1) && (nearfar == 1) ) {
        manual_security_nearfar = 3;
    }
    if ( (auto_num == 1) && (security_num == 0) && (nearfar == 0) ) {
        manual_security_nearfar = 4;
    }
    if ( (auto_num == 1) && (security_num == 0) && (nearfar == 1) ) {
        manual_security_nearfar = 5;
    }
    if ( (auto_num == 1) && (security_num == 1) && (nearfar == 0) ) {
        manual_security_nearfar = 6;
    }
    if ( (auto_num == 1) && (security_num == 1) && (nearfar == 1) ) {
        manual_security_nearfar = 7;
    }
}


- (IBAction)UpdateSettings:(id)sender {
    NSLog(@"Update Settings");
    
    [self func_setModes];
   
  
    NSString *post = [NSString stringWithFormat:@"&id=%s&gps_coordinates_lat=%d&gps_coordinates_lon=%d","123",manual_security_nearfar, device_config];
    
    NSData *postData = [post dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
    
    NSString *postLength = [NSString stringWithFormat:@"%lu",(unsigned long)[postData length]];
    
    NSMutableURLRequest *requestPost = [[NSMutableURLRequest alloc] init];
    
    [requestPost setURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://dev.m.gatech.edu/d/rsrs3/w/SilentGardian/c/api/updateGpsLocation"]]];
    
    //[requestPost setURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://dev.m.gatech.edu/d/rsrs3/w/SilentGardian/c/api/gpsLocation/"]]];
    
    //http://dev.m.gatech.edu/d/rsrs3/w/SilentGardian/c/api/gpsLocation/
    
    [requestPost setHTTPMethod:@"POST"];
    
    [requestPost setValue:postLength forHTTPHeaderField:@"Content-Length"];
    
    [requestPost setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Current-Type"];
    
    [requestPost setHTTPBody:postData];
    
    NSURLConnection *conn = [[NSURLConnection alloc]initWithRequest:requestPost delegate:self];
    
    if(conn)
    {
        NSLog(@"Connection Successful");
    }
    else
    {
        NSLog(@"Connection could not be made");
    }

    
    
}



@end
